      PROGRAM QCZERF
C-----------------------------------------------------------------------
C     PROGRAM TO TEST SUBROUTINE CERF FOR THE COMPLEX ERROR FUNCTION
C     AGAINST THE NBS HANDBOOK (A&S) VALUES (CHAPTER 7)
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PI=4.0D0*DATAN(1.0D0)
      HRPI=0.5D0*DSQRT(PI)
    5 CONTINUE
      PRINT *,' '
      PRINT *,'CASES 3 THRU 6 REPRODUCE TABLES IN A&S CHAPTER 7'
      PRINT *,' '
      PRINT *,'ICASE=1: CHECKS ERF(X)+ERFC(X)-1=0 FOR X.GE.0'
      PRINT *,'ICASE=2: CHECKS ODDNESS OF ERF(Z): ERF(Z)+ERF(-Z)=0'
      PRINT *,'ICASE=3: DAWSON INTEGRAL=ERF(I*Y)/I TABLE 7.5, Y.LE.2'
      PRINT *,'ICASE=4: DAWSON INTEGRAL=ERF(I*Y)/I TABLE 7.5, Y.GE.2'
      PRINT *,'ICASE=5: FRESNEL INTEGRALS C(X), S(X) TABLE 7.7' 
      PRINT *,'ICASE=6: W(Z)=CEXP(-Z*Z)*ERFC(-I*Z), TABLE 7.9'
      PRINT *,'ICASE=7: CHECKS W(Z) AGAINST A DP QUADRATURE'
      PRINT *,'ICASE=8: CHECKS CONJG(W(Z))-W(CONJG(Z))=0 FOR X.LT.0'
      PRINT *,'ICASE=9: EXIT PROGRAM'
      PRINT *,' '
      PRINT *,'INPUT THE CASE (1 TO 9): '
      READ *,ICASE
      IF (ICASE.LE.0) THEN
        PRINT *,'ICASE MUST BE BETWEEN 1 AND 9 INCLUSIVELY'
        GO TO 5
      ENDIF
      IF(ICASE.GT.8) GOTO 6
      KOUNT=0
      IF(ICASE.EQ.1) THEN
C--------------------------------------------------
C     ICASE=1     ERF(X)+ERFC(X)=1, X.GT.0.0 ,Y=0.0
C--------------------------------------------------
        KODE=1
        KKODE=2
        JL=1
        IL=88
        PRINT *, "            CHECK IDENTITY   ERF(X)+ERFC(X)=1"
        PRINT *, "              Z                        RESULT"
        DO 20 J=1,JL
          Y=DBLE(FLOAT(J-1))/10.0D0
        DO 10 I=1,IL
          X=DBLE(FLOAT(I-1))/10.0D0
          ZR=X
          ZI=Y
          ZTR=X
          ZTI=0.0D0
          CALL ZERF(ZTR,ZTI,KKODE,CY5R,CY5I,IERR)
          EX=DEXP(-X*X)
          CY5R=CY5R*EX
          CY5I=CY5I*EX
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          CYR=CYR+CY5R-1.0D0
          CYI=CYI+CY5I
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,20).EQ.0) THEN
            PAUSE
            PRINT *, "            CHECK IDENTITY   ERF(X)+ERFC(X)=1"
            PRINT *,"              Z                        RESULT"
          ENDIF
          PRINT 900,ZR,ZI,CYR,CYI
  900     FORMAT(4D14.6)
   10   CONTINUE
   20   CONTINUE
      ENDIF
      IF (ICASE.EQ.2) THEN
C--------------------------------------------
C     ICASE=2     CHECK FOR ODDNESS OF ERF(Z)
C--------------------------------------------
        KODE=1
        JL=15
        IL=15
        PRINT *,"     ODDNESS CHECK FOR COMPLEX ERROR FUNCTION"
        PRINT *,"              Z                        RESULT"
        DO 130 J=1,JL
          Y=DBLE(FLOAT(J-1))/2.0D0
        DO 140 I=1,IL
          X=DBLE(FLOAT(I-1))/2.0D0
          ZR=X
          ZI=Y
          CALL ZERF(ZR,ZI,KODE,CY7R,CY7I,IERR)
          ZTR=-ZR
          ZTI=-ZI
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          CYR=CYR+CY7R
          CYI=CYI+CY7I
          XX=ZABS(CY7R,CY7I)
          IF(XX.NE.0.0D0) THEN
            CYR=CYR/XX
            CYI=CYI/XX
          ENDIF
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,20).EQ.0) THEN
            PAUSE
            PRINT *,"     ODDNESS CHECK FOR COMPLEX ERROR FUNCTION"
            PRINT *,"              Z                        RESULT"
          ENDIF
          PRINT 900,ZR,ZI,CYR,CYI
  140   CONTINUE
  130   CONTINUE
      ENDIF
      IF(ICASE.EQ.3) THEN
C--------------------------------------------------
C     ICASE=3     DAWSON'S INTEGRAL=F(Y)=ERF(I*Y)/I
C--------------------------------------------------
        KODE=1
        JL=36
        IL=1
        PRINT *,"       DAWSON'S INTEGRAL, Y.LE.2.0, TABLE 7.5"
        PRINT *,"              Z                        RESULT"
        DO 30 J=1,JL
          Y=DBLE(FLOAT(J-1))/5.0D0
        DO 40 I=1,IL
          X=DBLE(FLOAT(I-1))/10.0D0
          ZR=X
          ZI=Y
          COEF=HRPI*DEXP(-Y*Y)
          ZTR=0.0D0
          ZTI=Y
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          CYR=COEF*CYR
          CYI=COEF*CYI
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,20).EQ.0) THEN
            PAUSE
            PRINT *,"       DAWSON'S INTEGRAL, Y.LE.2.0, TABLE 7.5"
            PRINT *,"              Z                        RESULT"
          ENDIF
          PRINT 900,ZR,ZI,CYR,CYI
  40   CONTINUE
  30   CONTINUE
      ENDIF
      IF(ICASE.EQ.4) THEN
C---------------------------------------------------------
C     ICASE=4     DAWSON'S INTEGRAL=F(Y)=ERF(I*Y)/I,Y.GT.2
C---------------------------------------------------------
        KODE=1
        JL=48
        IL=1
        PRINT *,"      DAWSON'S INTEGRAL, Y.GE.2.0, TABLE 7.5"
        PRINT *,"                 1/(Y*Y)              RESULT"
        DO 50 J=1,JL
          Y=DBLE(FLOAT(J-1))/5.0D0
        DO 60 I=1,IL
          X=DBLE(FLOAT(I-1))/10.0D0
          R=0.250D0-DBLE(FLOAT(J-1))*0.005D0
          Y=1.0D0/DSQRT(R)
          COEF=HRPI*Y*DEXP(-Y*Y)
          ZTR=0.0D0
          ZTI=Y
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          CYR=COEF*CYR
          CYI=COEF*CYI
          ZR=0.0D0
          ZI=R
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,20).EQ.0) THEN
            PAUSE
            PRINT *,"      DAWSON'S INTEGRAL, Y.GE.2.0, TABLE 7.5"
            PRINT *,"                 1/(Y*Y)              RESULT"
          ENDIF
          PRINT 900,ZR,ZI,CYR,CYI
   60   CONTINUE
   50   CONTINUE
      ENDIF
      IF(ICASE.EQ.5) THEN
C---------------------------------------------
C     ICASE=5     FRESNEL INTEGRALS C(X), S(X)
C---------------------------------------------
        KODE=1
        JL=1
        IL=31
        PRINT *,"            FRESNEL INTEGRALS TABLE 7.7"
        PRINT *,"      X                         C(X)         S(X)"
        DO 70 J=1,JL
          Y=DBLE(FLOAT(J-1))/5.0D0
        DO 80 I=1,IL
          X=DBLE(FLOAT(I-1))/10.0D0
          COEFR=0.5D0
          COEFI=0.5D0
          ZTR=HRPI*X
          ZTI=-HRPI*X
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          CALL ZMLT(COEFR,COEFI,CYR,CYI,CYR,CYI)
          ZR=X
          ZI=0.0D0
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,20).EQ.0) THEN
            PAUSE
            PRINT *,"            FRESNEL INTEGRALS TABLE 7.7"
            PRINT *,"      X                         C(X)         S(X)"
          ENDIF
          PRINT 900,ZR,ZI,CYR,CYI
   80   CONTINUE
   70   CONTINUE
      ENDIF
      IF(ICASE.EQ.6) THEN
C-----------------------------------------
C     ICASE=6     EXP(-Z*Z)*ERFC(-I*Z)
C-----------------------------------------
        KODE=2
        JL=7
        IL=21
        PRINT *,"             COMPLEX ERROR FUNCTION TABLE 7.9"
        PRINT *,"              Z                        RESULT"        
        DO 90 I=1,IL
          X=DBLE(FLOAT(I-1))/5.0D0
        DO 100 J=1,JL
          Y=DBLE(FLOAT(J-1))/2.0D0
          ZR=X
          ZI=Y
          COEF=1.0D0
          ZTR=Y
          ZTI=-X
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,20).EQ.0) THEN
            PAUSE
            PRINT *,"             COMPLEX ERROR FUNCTION TABLE 7.9"
            PRINT *,"              Z                        RESULT"
          ENDIF
          PRINT 900,ZR,ZI,CYR,CYI
  100   CONTINUE
   90   CONTINUE
      ENDIF
      IF(ICASE.EQ.7) THEN
C------------------------------------------------
C     ICASE=7     CHECK W(Z) AGAINST DP QUADRATURE
C------------------------------------------------
C       FORMULAE 7.4.13 & 7.4.14 REQUIRE Y.GT.0.0D0. THEREFORE THETA=0
C       AND THETA=PI ARE EXCLUDED
        TPI=PI+PI
        JL=14
        IL=39
        PRINT *,"    W(Z) COMPARED TO DP QUADRATURE OF A&S EQNS. 7.4.13
     && 7.4.14"
        PRINT *,"      R            THETA       REL ERR0R            RES
     &ULT"
        DO 150 J=1,JL
          R=DBLE(FLOAT(J))/2.0D0
        DO 160 I=1,IL
          IF(I.EQ.20) GOTO 160
          THET=TPI*DBLE(FLOAT(I))/40.0D0
          X=R*DCOS(THET)
          Y=R*DSIN(THET)
          ZR=X
          ZI=Y
          KODE=2
          ZTR=Y
          ZTI=-X
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          IF(IERR.EQ.2) THEN
            PRINT *, 'OVERFLOW FOR Z = ',ZTR,ZTI
            GOTO 160
          ENDIF
          DX=X
          DY=Y
          CALL ZW(DX,DY,WANSR,WANSI)
          DERRR=CYR-WANSR
          DERRI=CYI-WANSI
C          CERR=CMPLX(SNGL(DERRR),SNGL(DERRI))
          ERR=ZABS(DERRR,DERRI)
C          WANS=CMPLX(SNGL(WANSR),SNGL(WANSI))
          AZ=ZABS(WANSR,WANSI) 
          IF(AZ.NE.0.0D0) THEN
            ERR=ERR/AZ
          ENDIF
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,10).EQ.0) THEN
            PAUSE
            PRINT *,"    W(Z) COMPARED TO DP QUADRATURE OF A&S EQNS. 7.4
     &.13 & 7.4.14"
            PRINT *,"      R            THETA       REL ERR0R          
     & RESULT"
          ENDIF
          PRINT 905,R,THET,ERR,WANSR,WANSI
C         PRINT 906,CYR,CYI
  905     FORMAT(5E14.6)
C 906     FORMAT(42X,2E14.6)
  160   CONTINUE
  150   CONTINUE
      ENDIF
      IF (ICASE.EQ.8) THEN
C------------------------------------------------
C     ICASE=8     CHECK FOR CONJUGACY, NEGATIVE X
C------------------------------------------------
        KODE=2
        JL=15
        IL=15
        PRINT *,"   CONJUGACY CHECK FOR COMPLEX ERROR FUNCTION"
        PRINT *,"              Z                        RESULT"
        DO 110 J=1,JL
          Y=DBLE(FLOAT(J-1))/2.0D0
        DO 120 I=1,IL
          X=DBLE(FLOAT(I-1))/2.0D0
          ZR=-X
          ZI=-Y
          ZTR=ZR
          ZTI=ZI
          CALL ZERF(ZTR,ZTI,KODE,CY6R,CY6I,IERR)
          CY6I=-CY6I 
          ZTI=-ZTI
          CALL ZERF(ZTR,ZTI,KODE,CYR,CYI,IERR)
          CYR=CYR-CY6R
          CYI=CYI-CY6I
          XX=ZABS(CY6R,CY6I)
          IF (XX.NE.0.0) THEN
            CYR=CYI/XX
            CYI=CYI/XX
          ENDIF
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,20).EQ.0) THEN
            PAUSE
            PRINT *,"   CONJUGACY CHECK FOR COMPLEX ERROR FUNCTION"
            PRINT *,"              Z                        RESULT"
          ENDIF
          PRINT 900,ZR,ZI,CYR,CYI
  120   CONTINUE
  110   CONTINUE
      ENDIF
      GO TO 5
    6 CONTINUE
      END
      SUBROUTINE ZW(DX,DY,WANSR,WANSI)
C
C     PLAZMA DISPERSION FUNCTION W(Z)=DEXP(-Z*Z)*ERFC(-I*Z) BY
C     DOUBLE PRECISION QUADRATURE, Z=X+I*Y.
C
C     DX AND DY ARE DOUBLE PRECISION, Z=DX+I*DY
C     WANSR=DOUBLE PRECISION REAL PART OF W(Z)
C     WANSI=DOUBLE PRECISION IMAGINARY PART OF W(Z)
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      COMMON/CDQWZ/PN,CX,CY,IR
      DATA PI /3.14159265358979D0/
      EXTERNAL DQWZ
      X=DX
      Y=DY
      IF(DY.LT.0.0D0) THEN
        X=-DX
        Y=-DY
      ENDIF
      CX=X
      CY=Y
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=1.0D0
      IR=0
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=-1.0D0
      IR=0
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      WANSR=(QANSP+QANSN)/PI
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=1.0D0
      IR=1
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=-1.0D0
      IR=1
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      WANSI=(QANSP+QANSN)/PI
      IF(DY.LT.0.0D0) THEN
        DZ2R=DX*DX-DY*DY
        DEX=DEXP(-DZ2R)
        DTXY=2.0D0*DX*DY
        DSXY=DSIN(DTXY)
        DCXY=DCOS(DTXY)
        DTRMR=DEX*DCXY
        DTRMI=-DEX*DSXY
        WANSR=DTRMR+DTRMR-WANSR
        WANSI=DTRMI+DTRMI-WANSI
      ENDIF
      RETURN
      END
      DOUBLE PRECISION FUNCTION DQWZ(T)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      COMMON/CDQWZ/PN,CX,CY,IR
      A=CX-PN*T
      IF(IR.EQ.0) THEN
        B=CY
      ELSE
        B=A
      ENDIF
      TEMP=B/(A*A+CY*CY)
      DQWZ=TEMP*DEXP(-T*T)
      RETURN
      END
      PROGRAM ZBNDRYCF
C     TESTS THE ACCURACY OF THE DP CONTINUED FRACTION FOR
C     EXP(Z*Z)*ERFC(Z) WITH N=INT(C/AZ)+5 AGAINST DP QUADRATURE FOR
C     W(I*Z). C=75.0 SUFFICES FOR ERRORS O(10**(-15)) ALONG THE BOUNDARY
C     X=1.5D0, Y>=0.0D0, AZ=CABS(Z).
C
C     USES ZMATH AND AMOSSUBS
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      ICASE=7
      IF(ICASE.EQ.7) THEN
C       FORMULAE 7.4.13 & 7.4.14 REQUIRE Y.GT.0.0E0.
        JL=31
        IL=101
        PRINT *,"CF COMPARED TO DP QUADRATURE OF W(I*Z) A&S EQNS. 7.4.13
     & & 7.4.14"
            PRINT *,"      X              Y          REL ERR0R          
     & RESULT"
        EPS=1.0D-14
        DO 10 K=1,2
        DO 150 J=1,JL
          X=-EPS+1.5D0+DBLE(FLOAT(J-1))/20.0D0 
        DO 160 I=1,IL
          Y=6.0D0*DBLE(FLOAT(I-1))/100.0D0
C         Z=CMPLX(X,Y)
          ZR=X
          ZI=Y
          KODE=2
          CALL CONTFRAC(ZR,ZI,KODE,CYR,CYI,IERR)
          IF(IERR.EQ.2) THEN
            PRINT *, 'OVERFLOW FOR Z = ',ZR,ZI
            GOTO 160
          ENDIF
C         Z IS REPLACED BY I*Z IN W TO GET EXP(Z*Z)*ERFC(Z)
C         I*Z=-Y + I*X
          DX=-Y
          DY=X
          CALL ZW(DX,DY,WANSR,WANSI)
          CANSR=CYR
          CANSI=CYI
          DERRR=CANSR-WANSR
          DERRI=CANSI-WANSI
          ERR=ZABS(DERRR,DERRI)
          IF(ZABS(WANSR,WANSI).NE.0.0D0) THEN
            ERR=ERR/ZABS(WANSR,WANSI)
          ENDIF
          KOUNT=KOUNT+1
          IF(MOD(KOUNT,10).EQ.0) THEN
            PAUSE
        PRINT *,"CF COMPARED TO DP QUADRATURE OF W(I*Z) A&S EQNS. 7.4.13
     & & 7.4.14"
            PRINT *,"      X              Y          REL ERR0R          
     & RESULT"
          ENDIF
          PRINT 905,ZR,ZI,ERR,WANSR,WANSI
          PRINT 906,CYR,CYI
          IF(I.EQ.1) THEN
            KKODE=3
            YY=DRERF(ZR,KKODE,NZ)
            XX=0.0D0
            PRINT 907,ZR,YY,XX
  907       FORMAT(D25.16,17X,2D14.6)
          ENDIF
  905     FORMAT(5D14.6)
  906     FORMAT(42X,2D14.6)
  160   CONTINUE
  150   CONTINUE
        EPS=-EPS
   10   CONTINUE  
      ENDIF
      END
      SUBROUTINE CONTFRAC(ZR,ZI,KODE,CANSR,CANSI,IERR)
C-----------------------------------------------------------------------
C     CONTINUED FRACTION FOR ERFC(Z), X.GT.1.5 AND CABS(Z).LE.6.0. 
C     N=INT(C/AZ+5.0) FOR ACCURACIES TOL=MAX(UNIT ROUND OFF,1.E-15)
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DATA FNORM,GNORM /1.12837916709551D0,  0.564189583547756D0/
      IERR=0
      AZ=ZABS(ZR,ZI)
      N=INT(SNGL((75.0D0/AZ+5.0D0)))
      FN=DBLE(FLOAT(N))
      CALL ZMLT(ZR,ZI,ZR,ZI,CZR,CZI)
C      TERM=CZ
      TERMR=CZR
      TERMI=CZI
      DO 30 I=1,N 
        FNH=FN-0.5D0
        TEMPR=FNH*TERMR
        TEMPI=FNH*TERMI
        DENR=FN+TERMR
        DENI=TERMI
        CALL ZDIV(TEMPR,TEMPI,DENR,DENI,ANSR,ANSI)
        TERMR=CZR+ANSR
        TERMI=CZI+ANSI
C        TERM=CZ+(FNH*TERM)/(FN+TERM)
        FN=FN-1.0D0
   30 CONTINUE
      IF(KODE.EQ.2) GO TO 35
C      CZ=-CZ
C      ER=REAL(CZ) 
C      IF(ABS(ER).GT.ELIM) THEN
C        IF(ER.GT.0.0E0) THEN
C          IERR=2
C          CANS=CMPLX(0.0E0,0.0E0)
C          RETURN
C        ELSE
C          RER=0.0E0
C        ENDIF
C      ELSE
C        RER=EXP(ER)
C      ENDIF
C      EI=AIMAG(CZ)
C      CEI=COS(EI) 
C      SEI=SIN(EI) 
C      CZ=CMPLX(RER,0.0E0)*CMPLX(CEI,SEI)
C      SUM=ZP*CMPLX(GNORM,0.0E0)/TERM
C      TERM=-CZ*SUM
   35 CONTINUE
      TEMPI=0.0D0
      CALL ZDIV(GNORM,TEMPI,TERMR,TERMI,ANSR,ANSI)
      CALL ZMLT(ZR,ZI,ANSR,ANSI,CANSR,CANSI)
C      CANS=ZP*CMPLX(GNORM,0.0E0)/TERM
      IF(ZR.GE.0.0D0) RETURN
C      ER=REAL(CZ) 
C      IF(ABS(ER).GT.ELIM) THEN
C        IF(ER.GT.0.0E0) THEN
C          IERR=2
C          CANS=CMPLX(0.0E0,0.0E0)
C          RETURN
C        ELSE
C          RER=0.0E0
C        ENDIF
C      ELSE
C        RER=EXP(ER)
C      ENDIF
C      EI=AIMAG(CZ)
C      CEI=COS(EI) 
C      SEI=SIN(EI) 
C      CZ=CMPLX(RER,0.0E0)*CMPLX(CEI,SEI)
C      CANS=CZ+CZ-CANS 
      RETURN
      END
      SUBROUTINE ZW(DX,DY,WANSR,WANSI)
C
C     PLAZMA DISPERSION FUNCTION W(Z)=DEXP(-Z*Z)*ERFC(-I*Z) BY
C     DOUBLE PRECISION QUADRATURE, Z=X+I*Y.
C
C     DX AND DY ARE DOUBLE PRECISION, Z=DX+I*DY
C     WANSR=DOUBLE PRECISION REAL PART OF W(Z)
C     WANSI=DOUBLE PRECISION IMAGINARY PART OF W(Z)
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      COMMON/CDQWZ/PN,CX,CY,IR
      DATA PI /3.14159265358979D0/
      EXTERNAL DQWZ
      X=DX
      Y=DY
      IF(DY.LT.0.0D0) THEN
        X=-DX
        Y=-DY
      ENDIF
      CX=X
      CY=Y
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=1.0D0
      IR=0
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=-1.0D0
      IR=0
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      WANSR=(QANSP+QANSN)/PI
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=1.0D0
      IR=1
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSP,IERR)
      INIT=0
      X1=0.0D0
      SIG=4.0D0
      REL=1.0D-15
      PN=-1.0D0
      IR=1
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      CALL DQUAD8(DQWZ,INIT,X1,SIG,REL,X2,QANSN,IERR)
      WANSI=(QANSP+QANSN)/PI
      IF(DY.LT.0.0D0) THEN
        DZ2R=DX*DX-DY*DY
        DEX=DEXP(-DZ2R)
        DTXY=2.0D0*DX*DY
        DSXY=DSIN(DTXY)
        DCXY=DCOS(DTXY)
        DTRMR=DEX*DCXY
        DTRMI=-DEX*DSXY
        WANSR=DTRMR+DTRMR-WANSR
        WANSI=DTRMI+DTRMI-WANSI
      ENDIF
      RETURN
      END
      DOUBLE PRECISION FUNCTION DQWZ(T)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      COMMON/CDQWZ/PN,CX,CY,IR
      A=CX-PN*T
      IF(IR.EQ.0) THEN
        B=CY
      ELSE
        B=A
      ENDIF
      TEMP=B/(A*A+CY*CY)
      DQWZ=TEMP*DEXP(-T*T)
      RETURN
      END



